using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Categories;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IWholesalePriceListRepository
    {
        Task<BaseResult> Add(WholesalePriceListElastic WholesalePriceList);

        Task<BaseResult> AddManyAsync(IEnumerable<WholesalePriceListElastic> WholesalePriceLists);

        Task<SmartTableResult<WholesalePriceListElastic>> Search(BoolQueryDescriptor<WholesalePriceListElastic> query);
    }

    public class WholesalePriceListRepository : IWholesalePriceListRepository
    {
        private readonly ElasticIndex<WholesalePriceListElastic> _dbContext;

        public WholesalePriceListRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<WholesalePriceListElastic>(settings.Value.ClusterUrl, "inventorywholesalepricelist");
        }

        public async Task<SmartTableResult<WholesalePriceListElastic>> Search(BoolQueryDescriptor<WholesalePriceListElastic> query)
        {
            return await _dbContext.Search(query);
        }

        public async Task<BaseResult> Add(WholesalePriceListElastic WholesalePriceList)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(WholesalePriceList);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }

        public async Task<BaseResult> AddManyAsync(IEnumerable<WholesalePriceListElastic> WholesalePriceLists)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(WholesalePriceLists);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }
    }
}